open Graphics

type 'a arbre = Vide | Noeud of ('a arbre * 'a * 'a arbre)

let grey = rgb 220 220 220

let dessine dy rad rad2 x y arbre =
  let rec aux x y lev = function
    | Vide -> ()
    | Noeud (Vide, c, Vide) ->
	let triangle = [| (x-rad2, y-rad2); (x-rad2,y+rad2); (x+rad2,y+rad2); (x+rad2,y-rad2)|] in
	set_color grey;
	fill_poly triangle;
	set_color black;
	draw_poly triangle;
	let (w,h) = text_size c in
	moveto (x-w/2) (y-h/2);
	draw_string c
    | Noeud (g, c, d) ->
	set_color black;
	draw_segments [| (x,y,x+lev,y-dy); (x,y,x-lev,y-dy) |];
	set_color grey;
	fill_circle x y rad;
	set_color black;
	draw_circle x y rad;
	let (w,h) = text_size c in
	moveto (x-w/2) (y-h/2);
	draw_string c;
	aux (x+lev) (y-dy) (2*rad) d;
	aux (x-lev) (y-dy) (2*rad) g
  in aux x y (2*rad) arbre

let flche x y dx ddx ddy =
  set_color black;
  draw_segments [| (x,y,x+dx,y); (x,y,x+ddx,y-ddy); (x,y,x+ddx,y+ddy) |]
	
let arbre1 = Noeud (Noeud (Noeud (Vide, "A", Vide), "B", Noeud (Vide, "C", Vide)), "D", Noeud (Vide, "E", Vide)) ;;
let arbre2 = Noeud (Noeud (Vide, "A", Vide), "B", Noeud (Noeud (Vide, "C", Vide), "D", Noeud (Vide, "E", Vide))) ;;

open_graph " 490x180" ;;
set_font "Courier-Bold";
set_text_size 16;
dessine 60 16 14 102 160 arbre1 ;;
dessine 60 16 14 388 160 arbre2 ;;
flche 310 100 (-100) (-10) 5 ;;

let rec fonts = "Times-Italic" :: "Times-Roman" :: fonts ;;

let rec draw_l fonts (x,y) = function
  | s::qs -> set_font (List.hd fonts); moveto x y; draw_string s;
      draw_l (List.tl fonts) (x + 1 + (fst (text_size s)), y) qs
  | _ -> () ;;


let coords1 = [ 122, 156;
		 90,  96; 152,  96;
		 25,  10;  81,  10 ] ;;
let labels1 = [ ["h"];
		["h"; "-1"]; ["h"; "-3"];
		["h"; "-2"]; ["h"; "-2-"; "p"] ] ;;

let coords2 = [ 408, 156;
	        374, 96; 440, 96;
		366, 10; 440, 10 ] ;;
let labels2 = [ ["h"; "-"; "p"];
		["h"; "-2"]; ["h"; "-1-"; "p"];
		["h"; "-2-"; "p"]; ["h"; "-3"] ] ;;

List.iter2 (draw_l fonts) coords1 labels1 ;;
List.iter2 (draw_l fonts) coords2 labels2 ;;
