open Graphics

type 'a arbre = Vide | Noeud of ('a arbre * 'a * 'a arbre)

let grey = rgb 220 220 220

let dessine dy rad rad2 x y arbre trois =
  let rec aux x y lev = function
    | Vide -> ()
    | Noeud (Vide, c, Vide) ->
	let triangle = [| (x-rad2, y-rad2); (x-rad2,y+rad2); (x+rad2,y+rad2); (x+rad2,y-rad2)|] in
	set_color grey;
	fill_poly triangle;
	set_color black;
	draw_poly triangle;
	let (w,h) = text_size c in
	moveto (x-w/2) (y-h/2);
	draw_string c
    | Noeud (g, c, d) ->
	set_color black;
	draw_segments [| (x,y,x+lev,y-dy); (x,y,x-lev,y-dy) |];
	set_color grey;
	fill_circle x y rad;
	set_color black;
	draw_circle x y rad;
	let (w,h) = text_size c in
	moveto (x-w/2) (y-h/2);
	draw_string c;
	aux (x+lev) (y-dy) (2*rad) d;
	aux (x-lev) (y-dy) (2*rad) g
  in aux x y (if trois then 4*rad else 2*rad) arbre

let flche x y dx ddx ddy =
  set_color black;
  draw_segments [| (x,y,x+dx,y); (x,y,x+ddx,y-ddy); (x,y,x+ddx,y+ddy) |]
	
let arbre1 = Noeud (Noeud (Noeud (Vide, "A", Vide), "B", Noeud (Noeud (Vide, "C", Vide), "D", Noeud (Vide, "E", Vide))), "F", Noeud (Vide, "G", Vide)) ;;
let arbre2 = Noeud (Noeud (Noeud (Noeud (Vide, "A", Vide), "B", Noeud (Vide, "C", Vide)), "D", Noeud (Vide, "E", Vide)), "F", Noeud (Vide, "G", Vide)) ;;
let arbre3 = Noeud (Noeud (Noeud (Vide, "A", Vide), "B", Noeud (Vide, "C", Vide)), "D", Noeud (Noeud (Vide, "E", Vide), "F", Noeud (Vide, "G", Vide))) ;;

open_graph " 695x240" ;;
set_font "Courier-Bold";
set_text_size 16;
dessine 60 16 14  82 220 arbre1 false ;;
dessine 60 16 14 328 220 arbre2 false ;;
dessine 60 16 14 580 190 arbre3 true ;;
flche 210 130 (-50) (-10) 5 ;;
flche 460 130 (-50) (-10) 5 ;;

let rec fonts = "Times-Italic" :: "Times-Roman" :: fonts ;;

let rec draw_l fonts (x,y) = function
  | s::qs -> set_font (List.hd fonts); moveto x y; draw_string s;
      draw_l (List.tl fonts) (x + 1 + (fst (text_size s)), y) qs
  | _ -> () ;;


let coords1 = [ 102, 216;
		 70, 156; 132, 156;
		 36,  96; 102,  96;
		 28,  10;  92,  10 ] ;;
let labels1 = [ ["h"];
		["h"; "-1"]; ["h"; "-3"];
		["h"; "-3"]; ["h"; "-2"];
		["h"; "-3-"; "p"]; ["h"; "-3-"; "q"] ] ;;

let coords2 = [ 348, 216;
		316, 156; 378, 156;
		284,  96; 346,  96;
		220,  10; 274,  10 ] ;;
let labels2 = [ ["h"];
		["h"; "-1"]; ["h"; "-3"];
		["h"; "-2"]; ["h"; "-3-"; "q"];
		["h"; "-3"]; ["h"; "-3-"; "p"] ] ;;

let coords3 = [ 600, 186;
		536, 126; 664, 126;
		472,  40; 528,  40; 592,  40; 664,  40 ] ;;
let labels3 = [ ["h"; "-1"];
		["h"; "-2"]; ["h"; "-2"];
		["h"; "-3"]; ["h"; "-3-"; "p"];["h"; "-3-"; "q"]; ["h"; "-3"] ] ;;

List.iter2 (draw_l fonts) coords1 labels1 ;;
List.iter2 (draw_l fonts) coords2 labels2 ;;
List.iter2 (draw_l fonts) coords3 labels3 ;;
