open Graphics

type 'a arbre = Vide | Noeud of ('a arbre * 'a * 'a arbre)

let bw_mode = try Sys.getenv "BW_MODE" <> "" with _ -> false
let r = if bw_mode then (black, white) else (white, red)
and n = (white, black)

let dessine dy rad rad2 x y arbre trois =
  let rec aux x y lev = function
    | Vide -> ()
    | Noeud (Vide, (c, (fcolor, bcolor)), Vide) ->
	let triangle = [| (x-rad2, y-rad2); (x-rad2,y+rad2); (x+rad2,y+rad2); (x+rad2,y-rad2)|] in
	set_color bcolor;
	fill_poly triangle;
	set_color black;
	draw_poly triangle;
	let (w,h) = text_size c in
	moveto (x-w/2) (y-h/2);
	set_color fcolor;
	draw_string c
    | Noeud (g, (c, (fcolor, bcolor)), d) ->
	set_color black;
	draw_segments [| (x,y,x+lev,y-dy); (x,y,x-lev,y-dy) |];
	set_color bcolor;
	fill_circle x y rad;
	set_color black;
	draw_circle x y rad;
	let (w,h) = text_size c in
	moveto (x-w/2) (y-h/2);
	set_color fcolor;
	draw_string c;
	aux (x+lev) (y-dy) (2*rad) d;
	aux (x-lev) (y-dy) (2*rad) g
  in aux x y (if trois then 4*rad else 2*rad) arbre

let flche x y dx ddx ddy =
  set_color black;
  draw_segments [| (x,y,x+dx,y); (x,y,x+ddx,y-ddy); (x,y,x+ddx,y+ddy) |]
	
let arbre1 = Noeud (Noeud (Noeud (Vide, ("A", n), Vide),
			   ("B", r),
			   Noeud (Noeud (Vide, ("C", n), Vide), ("D", r), Noeud (Vide, ("E", n), Vide))),
		    ("F", n), Noeud (Vide, ("G", n), Vide)) ;;
let arbre2 = Noeud (Noeud (Noeud (Noeud (Vide, ("A", n), Vide), ("B", r), Noeud (Vide, ("C", n), Vide)),
			   ("D", r),
			   Noeud (Vide, ("E", n), Vide)),
		    ("F", n), Noeud (Vide, ("G", n), Vide)) ;;
let arbre3 = Noeud (Noeud (Noeud (Vide, ("A", n), Vide), ("B", r), Noeud (Vide, ("C", n), Vide)),
		    ("D", n),
		    Noeud (Noeud (Vide, ("E", n), Vide), ("F", r), Noeud (Vide, ("G", n), Vide))) ;;

open_graph " 695x220" ;;
set_font "Courier-Bold";
set_text_size 16;
dessine 60 16 14  82 200 arbre1 false ;;
dessine 60 16 14 328 200 arbre2 false ;;
dessine 60 16 14 580 170 arbre3 true ;;
flche 210 110 (-50) (-10) 5 ;;
flche 460 110 (-50) (-10) 5 ;;

let rec fonts = "Times-Italic" :: "Times-Roman" :: fonts ;;

let rec draw_l fonts (x,y) = function
  | s::qs -> set_font (List.hd fonts); moveto x y; draw_string s;
      draw_l (List.tl fonts) (x + 1 + (fst (text_size s)), y) qs
  | _ -> () ;;

let coords1 = [ 101, 196; 132, 136; 102,  76 ] ;;
let coords2 = [ 347, 196; 378, 136; 284,  76 ] ;;
let labels1 = [ ["y"]; ["z"]; ["x"] ] ;;
let labels2 = [ ["y"]; ["z"]; ["x'"] ] ;;

List.iter2 (draw_l fonts) coords1 labels1 ;;
List.iter2 (draw_l fonts) coords2 labels2 ;;
