open Graphics

type 'a arbre = Vide | Noeud of ('a arbre * 'a * 'a arbre)

let bw_mode = try Sys.getenv "BW_MODE" <> "" with _ -> false

let      grey = rgb 200 200 200
and dark_grey = rgb 128 128 128
and dark_blue = rgb   0   0 128

let r = if bw_mode then (black, white) else (white,  red)
and n = (white, black)
and i = if bw_mode then (black,      grey) else (white,      blue)
and g = if bw_mode then (black, dark_grey) else (white, dark_blue)

let dessine dy rad rad2 x y arbre =
  let rec aux x y lev = function
    | Vide -> ()
    | Noeud (Vide, (c, (fcolor, bcolor)), Vide) ->
	let triangle = [| (x-rad2, y-rad2); (x-rad2,y+rad2); (x+rad2,y+rad2); (x+rad2,y-rad2)|] in
	set_color bcolor;
	fill_poly triangle;
	set_color black;
	draw_poly triangle;
	let (w,h) = text_size c in
	moveto (x-w/2) (y-h/2);
	set_color fcolor;
	draw_string c
    | Noeud (g, (c, (fcolor, bcolor)), d) ->
	set_color black;
	draw_segments [| (x,y,x+lev,y-dy); (x,y,x-lev,y-dy) |];
	set_color bcolor;
	fill_circle x y rad;
	set_color black;
	draw_circle x y rad;
	let (w,h) = text_size c in
	moveto (x-w/2) (y-h/2);
	set_color fcolor;
	draw_string c;
	aux (x+lev) (y-dy) (2*rad) d;
	aux (x-lev) (y-dy) (2*rad) g
  in aux x y (2*rad) arbre

let flche x y dx ddx ddy =
  set_color black;
  draw_segments [| (x,y,x+dx,y); (x,y,x+ddx,y-ddy); (x,y,x+ddx,y+ddy) |]
	
let arbre1 = Noeud (Noeud (Vide, ("A", n), Vide),
		    ("B", i),
		    Noeud (Noeud (Vide, ("C", n), Vide), ("D", n), Noeud (Vide, ("E", n), Vide))) ;;
let arbre2 = Noeud (Noeud (Vide, ("A", n), Vide),
		    ("B", g),
		    Noeud (Noeud (Vide, ("C", n), Vide), ("D", r), Noeud (Vide, ("E", n), Vide))) ;;

open_graph " 380x160" ;;
set_font "Courier-Bold";
set_text_size 16;
dessine 60 16 14  52 140 arbre1 ;;
dessine 60 16 14 298 140 arbre2 ;;
flche 235 80 (-100) (-10) 5 ;;

let rec fonts = "Times-Italic" :: "Times-Roman" :: fonts ;;

let rec draw_l fonts (x,y) = function
  | s::qs -> set_font (List.hd fonts); moveto x y; draw_string s;
      draw_l (List.tl fonts) (x + 1 + (fst (text_size s)), y) qs
  | _ -> () ;;

let coords1 = [  72, 136; 103,  76;  39,  76 ] ;;
let labels1 = [ ["y"]; ["z"]; ["x"] ] ;;
let coords2 = [ 318, 136 ] ;;
let labels2 = [ ["x'"] ] ;;

List.iter2 (draw_l fonts) coords1 labels1 ;;
List.iter2 (draw_l fonts) coords2 labels2 ;;
