open Graphics

type 'a arbre = Vide | Noeud of ('a arbre * 'a * 'a arbre)

let grey = rgb 220 220 220

let dessine dy rad rad2 x y arbre =
  let rec aux x y lev = function
    | Vide -> ()
    | Noeud (Vide, c, Vide) ->
	let triangle = [| (x-rad2, y-rad2); (x-rad2,y+rad2); (x+rad2,y+rad2); (x+rad2,y-rad2)|] in
	set_color grey;
	fill_poly triangle;
	set_color black;
	draw_poly triangle;
	let (w,h) = text_size c in
	moveto (x-w/2) (y-h/2);
	draw_string c
    | Noeud (g, c, d) ->
	set_color black;
	draw_segments [| (x,y,x+lev,y-dy); (x,y,x-lev,y-dy) |];
	set_color grey;
	fill_circle x y rad;
	set_color black;
	draw_circle x y rad;
	let (w,h) = text_size c in
	moveto (x-w/2) (y-h/2);
	draw_string c;
	aux (x+lev) (y-dy) (2*rad) d;
	aux (x-lev) (y-dy) (2*rad) g
  in aux x y (2*rad) arbre

let flche x y dx ddx ddy =
  set_color black;
  draw_segments [| (x,y,x+dx,y); (x,y,x+ddx,y-ddy); (x,y,x+ddx,y+ddy) |]
	
let arbre1 = Noeud (Noeud (Noeud (Vide, "A", Vide), "B", Noeud (Vide, "C", Vide)), "D", Noeud (Vide, "E", Vide)) ;;
let arbre2 = Noeud (Noeud (Vide, "A", Vide), "B", Noeud (Noeud (Vide, "C", Vide), "D", Noeud (Vide, "E", Vide))) ;;

open_graph " 500x160" ;;
set_font "Courier-Bold";
set_text_size 16;
dessine 60 16 14 102 140 arbre1 ;;
dessine 60 16 14 398 140 arbre2 ;;
set_font "Times-Italic";
flche 300 110 (-100) (-10)  5  ;;
flche 200  50   100    10 (-5) ;;
set_text_size 24;
moveto 180 118; draw_string "rotation droite";;
moveto 175  30; draw_string "rotation gauche";;
