(** Extension de syntaxe pour les arbres rouge-noir *)

open Pcaml ;;

EXTEND
  GLOBAL: expr patt;
  rnterm_exp:
    [ [ "("; g = rnterm_exp; r = LIDENT; d = rnterm_exp; ")" ->
	  <:expr< Noeud $g$ $lid:r^"c"$ $lid:r^"x"$ $lid:r^"v"$ $d$ >>
      | a = LIDENT -> <:expr< $lid:a$ >>
      | "{"; e = expr; "}" -> e
      | "("; g = rnterm_exp; r = LIDENT; "["; c = expr; "]";
	  d = rnterm_exp; ")" ->
	    <:expr< Noeud $g$ $c$ $lid:r^"x"$ $lid:r^"v"$ $d$ >>
      ] ] ;
  rnterm_pat:
    [ [ "("; g = rnterm_pat; r = LIDENT; d = rnterm_pat; ")" ->
	  <:patt< Noeud $g$ $lid:r^"c"$ $lid:r^"x"$ $lid:r^"v"$ $d$ >>
      | "("; g = rnterm_pat; r = "_"; d = rnterm_pat; ")" ->
	  <:patt< Noeud $g$ _ _ _ $d$ >>
      | a = LIDENT -> <:patt< $lid:a$ >>
      | "{"; p = patt; "}" -> p
      | "_" -> <:patt< _ >>
      | "("; g = rnterm_pat; r = LIDENT; "["; c = patt; "]";
	  d = rnterm_pat; ")" ->
	    <:patt< Noeud $g$ $c$ $lid:r^"x"$ $lid:r^"v"$ $d$ >>
      | "("; g = rnterm_pat; r = "_"; "["; c = patt; "]";
	  d = rnterm_pat; ")" ->
	    <:patt< Noeud $g$ $c$ _ _ $d$ >>
      ] ] ;
  expr: LEVEL "simple"
    [ [ "@"; rn = rnterm_exp -> rn ] ];
  patt: LEVEL "simple"
    [ [ "@"; rn = rnterm_pat -> rn ] ];
  END;;
