(** Tests des cas les pires pour arbres binaires de recherche *)

open Printf
open Arbres_naifs

let nb_noeuds = try int_of_string (Sys.getenv "NB_NOEUDS") with _ -> 65536
let _ = try Gc.set { (Gc.get()) with Gc.verbose = (int_of_string (Sys.getenv "GC_VERBOSE")) } with _ -> ()

let chrono f a =
  let debut = Sys.time () in
  let res = f a in
  (Sys.time () -. debut, res)

let make () =
  let res = ref vide in
  for i = 0 to nb_noeuds-1 do
    res := inserer i 0 !res;
  done; !res

let destroy arbre =
  let debut = Sys.time () in
  let res = ref arbre in
  for i = nb_noeuds-1 downto 0 do
    res := supprimer i !res;
  done;
  let t = Sys.time () -. debut in (t, verifier !res)

let () =  
  printf "================================================================================\n";
  printf "Test de Arbres_naifs (cas le pire)\n";
  printf "nb_noeuds=%d\n" nb_noeuds;
  printf "Construction... "; flush stdout;
  let (t, arbre) = chrono make () in
  printf "OK (%.2f s)\n" t;
  printf "Vrification... "; flush stdout;
  let (t,(n,h)) = chrono verifier arbre in
  printf "OK : %d noeuds, hauteur=%d (%.2f s)\n" n h t;
  printf "================================================================================\n"
